# OPA-Tools

Welcome to the `OPA-Tools` package. This is a collection of tools and procedures to benchmark the [One_Pass](https://earth.bsc.es/gitlab/digital-twins/de_340-2/one_pass) package.

There are two main modules, **benchmark** and **request**.

- **benchmark** provides tools to set up, store, retrieve and review the benchmarks and useful metadata.

- **request** provides tools to produce, archive, query and review the kinds of requests related to the `One_Pass` package, i.e. the [`gsv` request](https://earth.bsc.es/gitlab/digital-twins/de_340-2/gsv_interface/-/blob/main/gsv/requests/processor.py) and the [`opa` request](https://earth.bsc.es/gitlab/digital-twins/de_340-2/one_pass/-/blob/main/docs/source/the_data_request.rst). Some flexibility is left to include *other kinds of requests*, which would be used to pass on parameters for different test features, such as concurrency and parallelization.

Besides, the package includes a few scripts, to perform tasks such as running the OPA or plot results.

## Installation

## Usage

The package needs to run with the environment variables `BENCHMARK_DIR` and `REQUEST_DIR`. They hold the local directory where, respectively, the benchmark results, and requests are stored. The evaluation of these variables is however postponed until needed.

### Platform setup

As of now, the intended usage of the package is as either one of the following platform setup options.

#### Single platform
One platform produces requests, runs OPA benchmarking with them, then investigates results.

#### Dual platform
Platform 1 produces requests, platform 2 runs and benchmarks OPA, then platform 1 visualizes benchmark results. This requires that both platforms have their `BENCHMARK_DIR` and `REQUEST_DIR` variables set. The command from platform 1 needs to be run:

```
rsync -avPz -e 'ssh -i /path/to/ssh/key' user@ip:/path/to/benchmarks/in/platform/2 /path/to/benchmarks/in/platform/1
rsync -avPz -e 'ssh -i /path/to/ssh/key' /path/to/requests/in/platform/1 user@ip:/path/to/requests/in/platform/2
```

This would send the requests from platform 1 to platform 2, and the benchmark results from platform 2 to platform 1, via `rsync` and an `ssh` connection.

**IMPORTANT** This means that platform 1 cannot perform benchmarks, as those would generate conflicts with the ssh connection. Strictly speaking, benchmarks are classified by date. This means that it suffices if platform 1 and platform 2 do not perform benchmarks on the same day.

#### Future work: Multiplatform

As future work, benchmarking on multiple platforms will be allowed. This means that there will be a central platform for request generation and archiving of benchmark traces and metadata. This is the purpose of the branch [`multiplatform`](https://gitlab.bsc.es/ialsina/opa-tools/-/tree/multiplatform).

## Author

Ivan Alsina Ferrer (BSC) [Email](mailto:ivan.alsina@bsc.es).

