from functools import lru_cache
from pathlib import Path
from typing import Union
import yaml

import numpy as np
import xarray as xr

@lru_cache(maxsize=None)
def read_dataset(path: Union[Path, str]):
    path = Path(path)
    data = xr.open_dataset(path, engine="netcdf4")
    data = data.compute()
    data = data.astype(np.float64)
    return data

def read_yaml(path: Union[Path, str]):
    path = Path(path)
    with open(path, "r") as rf:
        return yaml.safe_load(rf)

